use AdventureWorks2008R2
go

--	Intersect 
--	1a. Sales Person that sold in territory 1
--	and other territories too
select	soh.SalesPersonID
from	sales.SalesOrderHeader as soh
where	soh.TerritoryID = 1
and		soh.SalesPersonID is not null
intersect 
select	soh.SalesPersonID
from	sales.SalesOrderHeader as soh
where	soh.TerritoryID <> 1
and		soh.SalesPersonID is not null

--	1b. What territories did this person (274) sell in?
select	soh.SalesPersonID
		, soh.TerritoryID
		, COUNT(*) Territory_Count
from	sales.SalesOrderHeader as soh
where	soh.SalesPersonId = 274
group by soh.SalesPersonID, soh.TerritoryID
order by soh.TerritoryID

--	1c. What if we introduce The territory into the query?
select	soh.SalesPersonID, Soh.TerritoryID
from	sales.SalesOrderHeader as soh
where	soh.TerritoryID = 1
and		soh.SalesPersonID is not null
intersect 
select	soh.SalesPersonID, Soh.TerritoryID
from	sales.SalesOrderHeader as soh
where	soh.TerritoryID <> 1
and		soh.SalesPersonID is not null

--	There will be no results, since the two results sets are different
--	SalesPersonID	TerritoryID
--	274				1
--	INTERSECT
--	274				2
--	274				3
--	274				4
--	274				5
---	274				6

--	2. Interesect with multiple columns
--	2a. What products did you sell in multiple regions
select	soh.SalesPersonID, sod.ProductID
from	sales.SalesOrderHeader as soh
		inner join sales.SalesOrderDetail as sod
			on soh.SalesOrderID = sod.SalesOrderID
where	soh.TerritoryID = 1	
and		soh.SalesPersonID is not null
intersect 		
select	soh.SalesPersonID, sod.ProductID
from	sales.SalesOrderHeader as soh
		inner join sales.SalesOrderDetail as sod
			on soh.SalesOrderID = sod.SalesOrderID
where	soh.TerritoryID <> 1		
and		soh.SalesPersonID is not null
order by soh.SalesPersonID, sod.ProductID

--	2b. See where Sales Person 274 sold product 774
select	soh.SalesPersonID, sod.ProductID, soh.TerritoryID
from	sales.SalesOrderHeader as soh
		inner join sales.SalesOrderDetail as sod
			on soh.SalesOrderID = sod.SalesOrderID
where	soh.SalesPersonID = 274
and		sod.ProductID = 774
order by soh.TerritoryID, soh.SalesPersonID, sod.ProductID